<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosCobertura ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosCobertura extends AbstractStructArrayBase
{
    /**
     * The DadosCobertura
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DadosCobertura[]
     */
    public $DadosCobertura;
    /**
     * Constructor method for ArrayOfDadosCobertura
     * @uses ArrayOfDadosCobertura::setDadosCobertura()
     * @param \StructType\DadosCobertura[] $dadosCobertura
     */
    public function __construct(array $dadosCobertura = array())
    {
        $this
            ->setDadosCobertura($dadosCobertura);
    }
    /**
     * Get DadosCobertura value
     * @return \StructType\DadosCobertura[]|null
     */
    public function getDadosCobertura()
    {
        return $this->DadosCobertura;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosCobertura method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosCobertura method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosCoberturaForArrayConstraintsFromSetDadosCobertura(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosCoberturaDadosCoberturaItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosCoberturaDadosCoberturaItem instanceof \StructType\DadosCobertura) {
                $invalidValues[] = is_object($arrayOfDadosCoberturaDadosCoberturaItem) ? get_class($arrayOfDadosCoberturaDadosCoberturaItem) : sprintf('%s(%s)', gettype($arrayOfDadosCoberturaDadosCoberturaItem), var_export($arrayOfDadosCoberturaDadosCoberturaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosCobertura property can only contain items of type \StructType\DadosCobertura, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosCobertura value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosCobertura[] $dadosCobertura
     * @return \ArrayType\ArrayOfDadosCobertura
     */
    public function setDadosCobertura(array $dadosCobertura = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosCoberturaArrayErrorMessage = self::validateDadosCoberturaForArrayConstraintsFromSetDadosCobertura($dadosCobertura))) {
            throw new \InvalidArgumentException($dadosCoberturaArrayErrorMessage, __LINE__);
        }
        $this->DadosCobertura = $dadosCobertura;
        return $this;
    }
    /**
     * Add item to DadosCobertura value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosCobertura $item
     * @return \ArrayType\ArrayOfDadosCobertura
     */
    public function addToDadosCobertura(\StructType\DadosCobertura $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosCobertura) {
            throw new \InvalidArgumentException(sprintf('The DadosCobertura property can only contain items of type \StructType\DadosCobertura, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosCobertura[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosCobertura|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosCobertura|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosCobertura|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosCobertura|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosCobertura|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosCobertura
     */
    public function getAttributeName()
    {
        return 'DadosCobertura';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDadosCobertura
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
