<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for setDossierAssistenciaRequest StructType
 * @subpackage Structs
 */
class SetDossierAssistenciaRequest extends AbstractStructBase
{
    /**
     * The Agencia
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Agencia;
    /**
     * The IdRegisto
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IdRegisto;
    /**
     * The DossierAssistencia
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DossierAssistencia;
    /**
     * Constructor method for setDossierAssistenciaRequest
     * @uses SetDossierAssistenciaRequest::setAgencia()
     * @uses SetDossierAssistenciaRequest::setIdRegisto()
     * @uses SetDossierAssistenciaRequest::setDossierAssistencia()
     * @param int $agencia
     * @param string $idRegisto
     * @param string $dossierAssistencia
     */
    public function __construct($agencia = null, $idRegisto = null, $dossierAssistencia = null)
    {
        $this
            ->setAgencia($agencia)
            ->setIdRegisto($idRegisto)
            ->setDossierAssistencia($dossierAssistencia);
    }
    /**
     * Get Agencia value
     * @return int
     */
    public function getAgencia()
    {
        return $this->Agencia;
    }
    /**
     * Set Agencia value
     * @param int $agencia
     * @return \StructType\SetDossierAssistenciaRequest
     */
    public function setAgencia($agencia = null)
    {
        // validation for constraint: int
        if (!is_null($agencia) && !(is_int($agencia) || ctype_digit($agencia))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($agencia, true), gettype($agencia)), __LINE__);
        }
        $this->Agencia = $agencia;
        return $this;
    }
    /**
     * Get IdRegisto value
     * @return string|null
     */
    public function getIdRegisto()
    {
        return $this->IdRegisto;
    }
    /**
     * Set IdRegisto value
     * @param string $idRegisto
     * @return \StructType\SetDossierAssistenciaRequest
     */
    public function setIdRegisto($idRegisto = null)
    {
        // validation for constraint: string
        if (!is_null($idRegisto) && !is_string($idRegisto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idRegisto, true), gettype($idRegisto)), __LINE__);
        }
        $this->IdRegisto = $idRegisto;
        return $this;
    }
    /**
     * Get DossierAssistencia value
     * @return string|null
     */
    public function getDossierAssistencia()
    {
        return $this->DossierAssistencia;
    }
    /**
     * Set DossierAssistencia value
     * @param string $dossierAssistencia
     * @return \StructType\SetDossierAssistenciaRequest
     */
    public function setDossierAssistencia($dossierAssistencia = null)
    {
        // validation for constraint: string
        if (!is_null($dossierAssistencia) && !is_string($dossierAssistencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossierAssistencia, true), gettype($dossierAssistencia)), __LINE__);
        }
        $this->DossierAssistencia = $dossierAssistencia;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetDossierAssistenciaRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
